Add sessiond/SESSIOND_ prefix to sessiond testpoints
[lttng-tools.git] / tests / regression / tools / health / test_thread_exit
index 885ad194182736e147046d6d33c52b69ef3741fd..7622e356dd5d1fb190b3eec89cdd2a3cef62223b 100755 (executable)
@@ -28,8 +28,6 @@ NUM_TESTS=12
 
 source $TESTDIR/utils/utils.sh
 
 
 source $TESTDIR/utils/utils.sh
 
-print_test_banner "$TEST_DESC"
-
 if [ ! -f "$CURDIR/$SESSIOND_PRELOAD" ]; then
        BAIL_OUT "libhealthexit.so not available for this test."
 fi
 if [ ! -f "$CURDIR/$SESSIOND_PRELOAD" ]; then
        BAIL_OUT "libhealthexit.so not available for this test."
 fi
@@ -37,7 +35,7 @@ fi
 function test_thread_exit
 {
        test_thread_exit_name="$1"
 function test_thread_exit
 {
        test_thread_exit_name="$1"
-       test_thread_exit_code="$2"
+       test_thread_error_string="$2"
 
        diag "Test health failure with ${test_thread_exit_name}"
 
 
        diag "Test health failure with ${test_thread_exit_name}"
 
@@ -49,6 +47,8 @@ function test_thread_exit
 
        # Spawn sessiond with preload healthexit lib
        export LD_PRELOAD="$CURDIR/$SESSIOND_PRELOAD"
 
        # Spawn sessiond with preload healthexit lib
        export LD_PRELOAD="$CURDIR/$SESSIOND_PRELOAD"
+       # Set the socket timeout to 5 so the health check delta is set to 25.
+       export LTTNG_NETWORK_SOCKET_TIMEOUT=5
        start_lttng_sessiond
 
        # Cleanup some env. var.
        start_lttng_sessiond
 
        # Cleanup some env. var.
@@ -56,41 +56,59 @@ function test_thread_exit
        unset ${test_thread_exit_name}_EXIT
 
        # Check initial health status
        unset ${test_thread_exit_name}_EXIT
 
        # Check initial health status
-       $CURDIR/$HEALTH_CHECK_BIN &> /dev/null
+       $CURDIR/$HEALTH_CHECK_BIN > /dev/null
 
        # Wait
 
        # Wait
-       sleep 25
+       sleep 30
 
 
-       # Check health status, exit code should indicate failure
-       $CURDIR/$HEALTH_CHECK_BIN &> /dev/null
+       # Check health status
+       $CURDIR/$HEALTH_CHECK_BIN > ${STDOUT_PATH} 2> ${STDERR_PATH}
 
 
-       health_check_exit_code=$?
-
-       if [ $health_check_exit_code -eq $test_thread_exit_code ]; then
-               pass "Validate thread ${test_thread_exit_name} failure"
-               stop_lttng_sessiond
-       else
+       out=$(grep "${test_thread_error_string}" ${STDOUT_PATH} | wc -l)
+       if [ $out -eq 0 ]; then
                fail "Validate thread ${test_thread_exit_name} failure"
                fail "Validate thread ${test_thread_exit_name} failure"
-
-               diag "Health returned: $health_check_exit_code\n"
+               diag "Health returned:"
+               diag "stdout:"
+               file=${STDOUT_PATH}
+               while read line ; do
+                   diag "$line"
+               done < ${file}
+
+               diag "stderr:"
+               file=${STDERR_PATH}
+               while read line ; do
+                   diag "$line"
+               done < ${file}
 
                stop_lttng_sessiond
                return 1
 
                stop_lttng_sessiond
                return 1
+       else
+               pass "Validate thread ${test_thread_exit_name} failure"
+               stop_lttng_sessiond
        fi
 }
        fi
 }
+
 plan_tests $NUM_TESTS
 
 plan_tests $NUM_TESTS
 
-THREAD=("LTTNG_THREAD_MANAGE_CLIENTS"
-       "LTTNG_THREAD_MANAGE_APPS"
-       "LTTNG_THREAD_REG_APPS")
+print_test_banner "$TEST_DESC"
+
+THREAD=("LTTNG_SESSIOND_THREAD_MANAGE_CLIENTS"
+       "LTTNG_SESSIOND_THREAD_MANAGE_APPS"
+       "LTTNG_SESSIOND_THREAD_REG_APPS")
+
+ERROR_STRING=(
+       "Thread \"Session daemon command\" is not responding in component \"sessiond\"."
+       "Thread \"Session daemon application manager\" is not responding in component \"sessiond\"."
+       "Thread \"Session daemon application registration\" is not responding in component \"sessiond\"."
+)
 
 
-# Exit code value to indicate specific thread failure
-EXIT_CODE=(1 2 4)
+STDOUT_PATH=$(mktemp)
+STDERR_PATH=$(mktemp)
 
 THREAD_COUNT=${#THREAD[@]}
 i=0
 while [ "$i" -lt "$THREAD_COUNT" ]; do
 
 THREAD_COUNT=${#THREAD[@]}
 i=0
 while [ "$i" -lt "$THREAD_COUNT" ]; do
-       test_thread_exit "${THREAD[$i]}" "${EXIT_CODE[$i]}"
+       test_thread_exit "${THREAD[$i]}" "${ERROR_STRING[$i]}"
 
        if [ $? -eq 1 ]; then
                exit 1
 
        if [ $? -eq 1 ]; then
                exit 1
@@ -106,11 +124,13 @@ else
        isroot=0
 fi
 
        isroot=0
 fi
 
-skip $isroot "Root access is needed. Skipping LTTNG_THREAD_MANAGE_KERNEL tests." "3" ||
+skip $isroot "Root access is needed. Skipping LTTNG_SESSIOND_THREAD_MANAGE_KERNEL tests." "3" ||
 {
 {
-       test_thread_exit "LTTNG_THREAD_MANAGE_KERNEL" "8"
+       test_thread_exit "LTTNG_SESSIOND_THREAD_MANAGE_KERNEL" "Thread \"Session daemon kernel\" is not responding in component \"sessiond\"."
 }
 
 }
 
+rm -f ${STDOUT_PATH}
+rm -f ${STDERR_PATH}
 
 # TODO: Special case manage consumer, need to spawn consumer via commands.
 
 # TODO: Special case manage consumer, need to spawn consumer via commands.
-#"LTTNG_THREAD_MANAGE_CONSUMER"
+#"LTTNG_SESSIOND_THREAD_MANAGE_CONSUMER"
This page took 0.026093 seconds and 5 git commands to generate.